
__no_init
struct
{
 u32 q_frq;
 u32 R1;
 u32 R2;
 u32 Vref;
 u32 IC1;
 u32 IC2;
 u16 Ltrs; 
 u16 Vcc;
 u8  LV;
 
 u8 init;
} eep @ 0x4000; 

class //periph_init
{
 public:
 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;  
  PA_DDR = 1<<3;

  PB_CR1 = 0xff;
  PB_ODR = 0;
  PB_DDR = 1<<5|1<<4|1<<2|1<<1;

  PC_CR1 = 0xff;
  PC_ODR = 0;
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0;
  PD_DDR = 0xff;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->SWR   = 0xb4;
  while(!(CLK->SWCR&CLK_SWCR_SWIF));
  CLK->SWCR |= CLK_SWCR_SWEN;
  CLK->SWCR  = 0;
  CLK->ICKR |= CLK_ICKR_SWUAH;

  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2;
  CLK->PCKENR2 = CLK_PCKENR2_ADC|CLK_PCKENR2_AWU;
  CLK->CKDIVR  = 0;  
 } 
 void t2(u16 i_freq)  
 {
  TIM2->ARRH = eep.q_frq/i_freq-1>>8;
  TIM2->ARRL = eep.q_frq/i_freq-1;
  
  TIM2->IER   = TIM2_IER_UIE;
  TIM2->CR1   = 1;
 }
 void adc()
 {
  ADC1->CR1  = ADC1_CR1_CONT|ADC1_PRESSEL_FCPU_D18;
  ADC1->CR2  = ADC1_ALIGN_RIGHT;
  ADC1->CR3  = ADC1_CR3_DBUF;
  ADC1->CSR  = 0;
  ADC1->TDRL = 1<<3|1;
 } 
 
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(1); 
  IWDG_ReloadCounter();
 }
 void ee()
 {
#define wsgn 75
  if(eep.init!=wsgn)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init  = wsgn;
   eep.q_frq = 13824E3;
   eep.R1    = 20000;
   eep.R2    = 10000;
   eep.Vref  = 1850;
   eep.Ltrs  = 10500;
   eep.IC1   = 4000;
   eep.IC2   = 4000;   
   eep.Vcc   = 5000;
   eep.LV    = 3;
   
   FLASH_Lock(FLASH_MEMTYPE_DATA);   
  }
 } 
}cfg;

